<app-loading *ngIf="isLoading"></app-loading>
<div class="content-header">
  <mb-button *ngIf="!tabSelectIndex && pastPeriod && objFunction.import" (click)="showModalUploadFile(footerTmplUploadFile)" mbButtonSize="MEDIUM"
             mbButtonText="{{'common.button.uploadFile' | translate}}"
             mbButtonTextColor="#141ED2">
  </mb-button>
  <div *ngIf="tabSelectIndex && pastPeriod && objFunction.approve">
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="rejectAllocation()" *ngIf="isLock"
               mbButtonText="{{'goaManagement.approveListEmpAllocated.label.reject' | translate}}" mbButtonAvailableStyle="PRIMARY">
    </mb-button>
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" *ngIf="isLock"
               mbButtonText="{{'goaManagement.approveListEmpAllocated.label.approve' | translate}}" mbButtonAvailableStyle="PRIMARY"
               (click)="approveAllocation(1)">
    </mb-button>
  </div>
</div>
<ng-template #footerTmplUploadFile>
  <section class="flex-footer__uploadfile">
    <mb-button (click)="modalRef.getContentComponent().save()" mbButtonAvailableStyle="PRIMARY" mbButtonSize="VERY_LARGE"
               mbButtonText="{{'targerManager.button.btnSaveFile' | translate}}"
               mbButtonType="NO_BORDER"></mb-button>
    <mb-button (click)="modalRef.destroy()"
               class="flex-footer__uploadfile--button-left"
               mbButtonAvailableStyle="BtnCancelHasBorder" mbButtonText="{{'targerManager.button.btnCancel' | translate}}"></mb-button>
  </section>
</ng-template>
<div class="mb-tab">
  <nz-tabset nzType='editable-card' nzHideAdd (nzSelectChange)='changeTab($event)'
             [nzSelectedIndex]='tabSelectIndex'>
    <nz-tab nzTitle="{{'goaManagement.approveListEmpAllocated.label.listAllocation' | translate}}">
      <nz-card style="margin-bottom: 24px">
        <div nz-row [nzGutter]="[30, 10]">
          <div nz-col nzXs="5" nzLg="5">
            <employee-data-picker [mbCanText]="true" mbLabelText="{{'goaManagement.approveListEmpAllocated.label.empCode' | translate}}"
                                                 [ngModelOptions]="{standalone: true}" [multiple]="true" [isHideFullName]="true" [functionCode]="functionCode"
                                                 (selectedChange)="onChange($event)" ngModel="">
            </employee-data-picker>
          </div>
          <div nz-col nzXs="5" nzLg="5">
            <mb-input-text
              [(ngModel)]="fullName"
              mbType="default"
              [mbMaxLength]="100"
              [defaultInput]="true"
              mbPlaceholderText=""
              mbLabelText="{{ 'goaManagement.approveListEmpAllocated.label.fullName' | translate }}"
              [disabled]="true"
            >
            </mb-input-text>
          </div>
          <div nz-col nzXs="5" nzLg="5">
            <mb-input-text
              ngModel="{{orgName}}"
              mbType="default"
              [mbMaxLength]="100"
              [defaultInput]="true"
              mbPlaceholderText=""
              mbLabelText="{{ 'goaManagement.approveListEmpAllocated.label.org' | translate }}"
              [disabled]="true"
            >
            </mb-input-text>
          </div>
          <div nz-col nzXs="5" nzLg="5">
            <mb-select [(ngModel)]="paramsEmp.periodId" [mbDataSelects]="listPeriod" [mbShowSearch]="false"
                       mbPlaceholder="{{'goaManagement.approveListEmpAllocated.label.assessmentPeriod' | translate}}"
                       mbLabelText="{{'goaManagement.approveListEmpAllocated.label.assessmentPeriod' | translate}}" mbKeyLabel="periodName"
                       mbKeyValue="periodId" (ngModelChange)="changePeriod($event)"
            >
            </mb-select>
          </div>
          <div nz-col nzSpan="4" style="padding-right: 2rem;">
            <mb-select
              [mbDataSelects]="listAllocation"
              mbKeyLabel="name"
              mbKeyValue="value"
              mbLabelText="Trong/ngoài phân bổ"
              mbPlaceholder=""
              [mbOptionHeightPx]="58"
              [(ngModel)]="paramsEmp.apportion"
              (mbSelect)="getListEmployee()"
            ></mb-select>
          </div>
        </div>
        <div class="search-header">
          <mb-button mbButtonAvailableStyle="CUSTOM"
                     mbButtonText="{{'common.label.search' | translate}}" (click)="getListEmployee()"></mb-button>
        </div>
      </nz-card>
      <div class="offer-container">
        <p class="offer-container__label">{{'goaManagement.listEmpAllocated.label.amountInAllocation' | translate}} {{amountInAllocation}}/{{totalEmp}}</p>
        <div class="btn-lock">
          <nz-switch [(ngModel)]="isLock" (ngModelChange)="updateConfig($event)"></nz-switch>
          <span class="text">{{ 'goaManagement.approveListEmpAllocated.label.lockAndUnlock' | translate }}</span>
        </div>
      </div>
      <div class="ant-table-content">
        <nz-table [nzPageSize]="paginationCustom.total" [nzShowPagination]="false"
                  [nzData]="listData" [nzScroll]="listData?.length > 7 ? { y: '28rem' } : {}"
                  nzTableLayout="fixed" [nzSize]="TABLE_SIZE" class="data-table">
          <thead>
          <tr>
            <th scope="col" nzWidth="5%" class="text-center">{{'goaManagement.approveListEmpAllocated.table.stt' | translate}}</th>
            <th scope="col" nzWidth="8%">{{'goaManagement.approveListEmpAllocated.table.empCode' | translate}}</th>
            <th scope="col" nzWidth="12%">{{'goaManagement.approveListEmpAllocated.table.fullName' | translate}}</th>
            <th scope="col">{{'goaManagement.approveListEmpAllocated.table.orgName' | translate}}</th>
            <th scope="col">{{'goaManagement.approveListEmpAllocated.table.jobName' | translate}}</th>
            <th scope="col" nzWidth="12%">{{'goaManagement.approveListEmpAllocated.table.allocation' | translate}}</th>
            <th scope="col" nzWidth="7%"></th>
          </tr>
          </thead>
          <tbody>
          <tr *ngFor="let data of listData, let i = index">
            <td class="text-center">{{ i + 1 + paginationCustom.size * paginationCustom.pageIndex }}</td>
            <td>{{data.employeeCode}}</td>
            <td>{{data.fullName}}</td>
            <td class="text-overflow" nz-tooltip [nzTooltipTitle]="data.orgManagement">{{data.orgManagement}}</td>
            <td class="text-overflow" nz-tooltip [nzTooltipTitle]="data.title">{{data.title}}</td>
            <td>
              <mb-select
                [mbDataSelects]="listIOAllocationTable"
                mbKeyLabel="name"
                mbKeyValue="value"
                [mbLabelText]="null"
                [mbOptionHeightPx]="58"
                [(ngModel)]="data.apportion"
                (mbSelect)="changeAllocation(data)"
              ></mb-select>
            </td>
            <td>
              <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="save(data)" *ngIf="data.checkChanges && isLock && pastPeriod && objFunction.create"
                         mbButtonText="{{'common.button.save' | translate}}" mbButtonAvailableStyle="PRIMARY">
              </mb-button>
            </td>
          </tr>
          </tbody>
        </nz-table>
      </div>
      <div class="pagination" *ngIf="paginationCustom.total > 0">
        <div style="padding-left: 22px;">
          <img src="assets/images/icon/idea.svg" alt="" />
          <span>
      {{'common.paging.rangePage' | translate:{result:paginationCustom.total} }}
            {{paginationCustom.size * paginationCustom.pageIndex + 1}}
            {{'common.paging.to' | translate}}
            {{paginationCustom.size * paginationCustom.pageIndex +
          paginationCustom.numberOfElements}}
    </span>
        </div>
        <nz-pagination [nzPageIndex]="paginationCustom.pageIndex + 1"
                       (nzPageIndexChange)="changePage($event)" [nzTotal]="paginationCustom.total"
                       [nzPageSize]="paginationCustom.size"></nz-pagination>
      </div>
    </nz-tab>

    <nz-tab nzTitle="{{'goaManagement.approveListEmpAllocated.label.listOffer' | translate}}">
      <nz-card style="margin-bottom: 24px">
        <div nz-row [nzGutter]="[30, 10]">
          <div nz-col nzXs="5" nzLg="5">
            <employee-data-picker [mbCanText]="true" mbLabelText="{{'goaManagement.approveListEmpAllocated.label.empCode' | translate}}"
                                                 [ngModelOptions]="{standalone: true}" [multiple]="true" [isHideFullName]="true" [functionCode]="functionCode"
                                                 (selectedChange)="onChange($event)" ngModel="">
            </employee-data-picker>
          </div>
          <div nz-col nzXs="5" nzLg="5">
            <mb-input-text
              [(ngModel)]="fullNameOffer"
              mbType="default"
              [mbMaxLength]="100"
              [defaultInput]="true"
              mbPlaceholderText=""
              mbLabelText="{{ 'goaManagement.approveListEmpAllocated.label.fullName' | translate }}"
              [disabled]="true"
            >
            </mb-input-text>
          </div>
          <div nz-col nzXs="5" nzLg="5">
            <mb-input-text
              ngModel="{{orgNameOffer}}"
              mbType="default"
              [mbMaxLength]="100"
              [defaultInput]="true"
              mbPlaceholderText=""
              mbLabelText="{{ 'goaManagement.approveListEmpAllocated.label.org' | translate }}"
              [disabled]="true"
            >
            </mb-input-text>
          </div>
          <div nz-col nzSpan="5" style="padding-right: 2rem;">
            <mb-select
              [mbDataSelects]="listStatus"
              mbKeyLabel="name"
              mbKeyValue="value"
              mbLabelText="Trạng thái"
              mbPlaceholder=""
              [mbOptionHeightPx]="58"
              [(ngModel)]="params.flagStatus"
              (mbSelect)="getListOffer()"
            ></mb-select>
          </div>
          <div nz-col nzXs="4" nzLg="4">
            <mb-select [(ngModel)]="params.periodId" [mbDataSelects]="listPeriod" [mbShowSearch]="false"
                       mbPlaceholder="{{'goaManagement.approveListEmpAllocated.label.assessmentPeriod' | translate}}"
                       mbLabelText="{{'goaManagement.approveListEmpAllocated.label.assessmentPeriod' | translate}}" mbKeyLabel="periodName"
                       mbKeyValue="periodId" (ngModelChange)="changePeriod($event)"
            >
            </mb-select>
          </div>
        </div>
        <div class="search-header">
          <mb-button mbButtonAvailableStyle="CUSTOM"
                     mbButtonText="{{'common.label.search' | translate}}" (click)="getListOffer()"></mb-button>
        </div>
      </nz-card>
      <div class="offer-container">
        <p class="offer-container__label">{{'goaManagement.listEmpAllocated.label.amountInAllocation' | translate}} {{amountInAllocation}}/{{totalEmp}}</p>
      </div>
      <div class="ant-table-content">
        <nz-table [nzPageSize]="paginationCustom.total" [nzShowPagination]="false"
                  [nzData]="listDataOffer" [nzScroll]="listDataOffer?.length > 7 ? { y: '28rem' } : {}"
                  nzTableLayout="fixed" [nzSize]="TABLE_SIZE" class="data-table">
          <thead>
          <tr>
            <th scope="col" [nzDisabled]="listDataOffer.length === 0" [nzChecked]="checked"
                (nzCheckedChange)="onAllChecked($event)" nzWidth="2%" nzLeft></th>
            <th scope="col" nzWidth="5%" class="text-center">{{'goaManagement.approveListEmpAllocated.table.stt' | translate}}</th>
            <th scope="col" nzWidth="8%">{{'goaManagement.approveListEmpAllocated.table.empCode' | translate}}</th>
            <th scope="col" nzWidth="12%">{{'goaManagement.approveListEmpAllocated.table.fullName' | translate}}</th>
            <th scope="col">{{'goaManagement.approveListEmpAllocated.table.orgName' | translate}}</th>
            <th scope="col">{{'goaManagement.approveListEmpAllocated.table.jobName' | translate}}</th>
            <th scope="col" class="text-center" nzWidth="8%">{{'goaManagement.approveListEmpAllocated.table.status' | translate}}</th>
            <th scope="col" nzWidth="8%">{{'goaManagement.approveListEmpAllocated.table.beforeOffer' | translate}}</th>
            <th scope="col" nzWidth="8%">{{'goaManagement.approveListEmpAllocated.table.afterOffer' | translate}}</th>
            <th scope="col">{{'goaManagement.approveListEmpAllocated.table.reason' | translate}}</th>
          </tr>
          </thead>
          <tbody>
          <tr *ngFor="let data of listDataOffer, let i = index">
            <td [nzChecked]="setOfCheckedId.has(data.clcId)" [nzDisabled]="!!data.flagStatus" (nzCheckedChange)="onItemChecked(data.clcId, $event)"></td>
            <td class="text-center">{{ i + 1 + paginationCustom.size * paginationCustom.pageIndex }}</td>
            <td>{{data.employeeCode}}</td>
            <td>{{data.fullName}}</td>
            <td class="text-overflow" nz-tooltip [nzTooltipTitle]="data.orgName">{{data.orgName}}</td>
            <td class="text-overflow" nz-tooltip [nzTooltipTitle]="data.title">{{data.title}}</td>
            <td style="display: flex; justify-content: center">
              <nz-tag [class]="renderFlagStatus(data.flagStatus).class">
                {{renderFlagStatus(data.flagStatus).text}}
              </nz-tag>
            </td>
            <td>{{renderOffer(data.clcSuggest)}}</td>
            <td>{{renderOffer(data.clcChange)}}</td>
            <td class="text-overflow" nz-tooltip [nzTooltipTitle]="data.description">{{data.description}}</td>
          </tr>
          </tbody>
        </nz-table>
      </div>

      <div class="pagination" *ngIf="listDataOffer.length && paginationCustom.total > 0">
        <div style="padding-left: 22px;">
          <img src="assets/images/icon/idea.svg" alt="" />
          <span>
      {{'common.paging.rangePage' | translate:{result:paginationCustom.total} }}
            {{paginationCustom.size * paginationCustom.pageIndex + 1}}
            {{'common.paging.to' | translate}}
            {{paginationCustom.size * paginationCustom.pageIndex +
          paginationCustom.numberOfElements}}
    </span>
        </div>
        <nz-pagination [nzPageIndex]="paginationCustom.pageIndex + 1"
                       (nzPageIndexChange)="changePage($event)" [nzTotal]="paginationCustom.total"
                       [nzPageSize]="paginationCustom.size"></nz-pagination>
      </div>
    </nz-tab>
  </nz-tabset>
</div>
<mb-modal-confirm #modalCompReject
                  [modalHeader]="null"
                  [isVisibleCorrectionDialog]='false'
                  (sendApprovedValid)="reject($event, 2)"
                  [mbErrorDefs]="[
          { errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '250' }},
          { errorName: 'required', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }},
          { errorName: 'noAllowSpace', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }}]"
                  mbPlaceholderText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}"
                  titleInputText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}">
  >
</mb-modal-confirm>
